<?php
/*----------------------------------------------------+
|            Audit Trail For PHP-Fusion     
|-----------------------------------------------------+
| BY EDAN BOY PEDRAGOSA "alias" HACKERSOFT
| Web: http://hackersoft.ath.cx/
| email: hackersoft@yours.com                     
|----------------------------------------------------+
| Released under the terms and conditions of  
| the GNU General Public License              
+----------------------------------------------------*/

/* Get the url of the page */
function get_selfurl() {
    $full_url = 'http';
    $script_name = '';
    if(isset($_SERVER['REQUEST_URI'])) {
        $script_name = $_SERVER['REQUEST_URI'];
    } else {
        $script_name = $_SERVER['PHP_SELF'];
        if($_SERVER['QUERY_STRING']>' ') {
            $script_name .=  '?'.$_SERVER['QUERY_STRING'];
        }
    }
    if(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') {
        $full_url .=  's';
    }
    $full_url .=  '://';
    if($_SERVER['SERVER_PORT']!='80') {
        $full_url .=  $_SERVER['HTTP_HOST'].':'.$_SERVER['SERVER_PORT'].$script_name;
    } else {
        $full_url .=  $_SERVER['HTTP_HOST'].$script_name;
    }
    return $full_url;
}

//Detect User Browser Version Specific
function detect()
    {
    $browser = array ("IE","OPERA","MOZILLA","NETSCAPE","FIREFOX","SAFARI");
    $os = array ("WIN","MAC");
    $info['browser'] = "OTHER";
    $info['os'] = "OTHER";
    foreach ($browser as $parent)
        {
        $s = strpos(strtoupper($_SERVER['HTTP_USER_AGENT']), $parent);
        $f = $s + strlen($parent);
        $version = substr($_SERVER['HTTP_USER_AGENT'], $f, 9);
        $version = preg_replace('/[^0-9,.]/','',$version);
        if ($s)
            {
            $info['browser'] = $parent;
            $info['version'] = $version;
            }
        }
    foreach ($os as $val)
        {
        if (eregi($val,strtoupper($_SERVER['HTTP_USER_AGENT']))) $info['os'] = $val;
        }
    return $info;
    }

$d = detect();
$v = $d['version'];

//browser OS
$browser = strtolower($_SERVER['HTTP_USER_AGENT']);  
// Insert OS/Bots/Crawler/Spider Information 
if (eregi ("win", $browser)) {
	if ( strstr( $browser, '95' ) )
	{
		$os = 'Windows 95';
	}
	elseif ( ( strstr( $browser, '9x 4.9' ) ) || ( strstr( $browser, 'me' ) ) )
	{
		$os = 'Windows ME';
	}
	elseif ( strstr( $browser, '98' ) )
	{
		$os = 'Windows 98';
	}
	elseif ( strstr( $browser, '2000' ) || strstr( $browser, 'nt 5.0' ))// windows 2000, for opera ID
	{
		$os = 'Windows 2000/NT';
	}
	elseif ( strstr( $browser, 'xp' ) || strstr( $browser, 'nt 5.1' ) )// windows 2000, for opera ID
	{
		$os = 'Windows XP';
	}
	elseif ( strstr( $browser, '2003' ) || strstr( $browser, 'nt 5.2' ))// windows server 2003, for opera ID
	{
		$os = 'Windows 2003';
	}
	elseif ( strstr( $browser, 'nt 4'))// windows NT 4
	{
		$os = 'Windows NT4';
	}
	elseif ( strstr( $browser, 'nt 3'))// windows NT 3
	{
		$os = 'Windows NT3';
	}
	elseif ( strstr( $browser, 'ce' ) )// windows CE
	{
		$os = 'Windows CE';
	}else{
		$os = 'Windows';
	}
}elseif (eregi ("mac", $browser)) { // If browser header contains values which contain MAC then the OS must be a MAC
	$os = "Mac";
}elseif (eregi ("linux", $browser)) { 
	$os = "Linux";
}elseif (eregi ("OS/2", $browser)) { 
	$os = "OS/2";
}elseif (eregi ("BeOS", $browser)) { 
	$os = "BeOS";
}elseif (eregi ("unix", $browser) | eregi ("SunOS", $browser) | eregi ("FreeBSD", $browser) | eregi ("IRIX", $browser) | eregi ("HP-UX", $browser) | eregi ("OSF", $browser) | eregi ("AIX", $browser)) { 
	$os = "Unix";
}elseif (eregi ("google", $browser)) { 
	$os = "Google Bot/Adsense";
}elseif (eregi ("yahoo", $browser)) { 
	$os = "Yahoo Bot";
}elseif (eregi ("inktomi", $browser)) { 
	$os = "Inktomi Bot";
}elseif (eregi ("fast", $browser)) { 
	$os = "Fast Webcrawler";
}elseif (eregi ("msn", $browser)) { 
	$os = "MSN Bot";
}elseif (eregi ("ask", $browser)) { 
	$os = "Ask Jeeves/Teoma Bots";
}elseif (eregi ("scooter", $browser)) { 
	$os = "Altavista Bot";
}elseif (eregi ("openbot", $browser)) { 
	$os = "Open Bot Taiwan";
}elseif (eregi ("ia", $browser)) { 
	$os = "IA Archiver";
}elseif (eregi ("zyborg", $browser)) { 
	$os = "LookSmart Bot";
}elseif (eregi ("almaden", $browser)) { 
	$os = "IBM Bot";
}elseif (eregi ("baidu", $browser)) { 
	$os = "Baiduspider";
}elseif (eregi ("psbot", $browser)) { 
	$os = "PSBOT Image Crawler";
}elseif (eregi ("gigabot", $browser)) { 
	$os = "Gigabot Crawler";
}else{
	$os = "Unknown";
}


// Insert Browser Information /////////////
if (eregi ("msie", $browser)) { 
	$browser = "Internet Explorer ". $v;
}elseif (eregi ("konqueror", $browser)) { 
	$browser = "Konqueror";
}elseif (eregi ("icab", $browser)) { 
	$browser = "iCab";
}elseif (eregi ("Firefox", $browser)) { // If the browser header contains FIREFOX then the browser must be FIREFOX 
	$browser = "Mozilla Firefox " . $v;
} elseif (eregi ("mozilla", $browser)) { 
	$browser = "Mozilla ".$v;
}elseif (eregi ("libwww", $browser)) { 
	$browser = "Lynx";
}elseif (eregi ("netscape", $browser)) { 
	$browser = "Netscape";
}elseif (eregi ("safari", $browser)) { 
	$browser = "Safari";
}elseif (eregi ("AOL", $browser)) { 
	$browser = "AOL";
}

//end browser OS
$at_IP= USER_IP;
if ($userdata['user_name']<>""){
	$at_Name = $userdata['user_name'];
	$at_Level = $userdata['user_level'];
	$at_Groups = $userdata['user_groups'];
} else {
	$at_Name = 'Guest';
	$at_Level = $userdata['user_level'];
	$at_Groups = '';
}

$at_Page = get_selfurl();
$at_Date = time();
$at_Referrer = $_SERVER['HTTP_REFERER'];
$at_Browser = $browser;
$at_OS = $os;
$at_AgentDetail = $_SERVER['HTTP_USER_AGENT'];

if (FUSION_SELF <> "audit_trail_admin.php"){ //Don't include audit trail admin in logging
	$result = dbquery("INSERT INTO " . $db_prefix . "audit_trail (at_IP, at_Name, at_Level, at_Groups, at_Page, at_Date, at_Referrer, at_Browser, at_OS, at_AgentDetail) VALUES ('$at_IP', '$at_Name', '$at_Level', '$at_Groups', '$at_Page', '$at_Date', '$at_Referrer', '$at_Browser', '$at_OS', '$at_AgentDetail')");
}
?>